function mimo_MSF1DF_sim(pnummt,pdenmt,pdeadmt,mnummt,mdenmt,mdeadmt,pdnummt,pddenmt,...
   q,order,qnummt,qdenmt,x,y,Epsilon,Satub,Satlb)
global time st_size M1_handle1 X_handle Plot_handle figMSF_h
global COLOR_MAP E1_handle Keep_handle axis_handle M1_handle2

%MSF Controller
%-----------------------------------------------
[input_delay,dec_M,qdeadmt]=dtarray(mdeadmt,y);
[T,qdeadmt]=transform(qdeadmt);
[Ksp,K,Kdelay,Kspstr,Kstr,Ds,Dstr]=msfgainM(q,order,Epsilon,mdeadmt,qnummt,qdenmt,y);

%Model
%------------------------------------------------
n=length(order);
for i=1:n
   for j=1:n
      Mnum{i,j}=mt2poly(mnummt{i,j},y);
      Mden{i,j}=mt2poly(mdenmt{i,j},y);
      Mdead{i,j}=mt2poly(mdeadmt{i,j},y);
   end
end

%Process
%-----------------------------------------------
if any(isCellempty(pnummt)) | any(isCellempty(pdenmt))
   Pnum=Mnum;
   Pden=Mden;
   Pdead=Mdead;
else
for i=1:n
   for j=1:n
      Pnum{i,j}=mt2poly(pnummt{i,j},x);
      Pden{i,j}=mt2poly(pdenmt{i,j},x);
      Pdead{i,j}=mt2poly(pdeadmt{i,j},x);
   end
end
end
%Pd
%------------------------------------------------
for i=1:n
   for j=1:n
      Pdnum{i,j}=mt2poly(pdnummt{i,j},y);
      Pdden{i,j}=mt2poly(pddenmt{i,j},y);
      Pddead{i,j}=0;
   end
end
color_step=round(64/n/n)-1;
options = simset('SrcWorkspace','current','MaxStep',st_size);
sim_fun=['mimoMSF1df' num2str(n)];
for j=1:n
   Setpoint=zeros(1,n); Disturb=Setpoint;
   if get(Plot_handle(1),'Value')==1
      Setpoint(j)=1;
   else
      Disturb(j)=1;
   end
   [t]=sim(sim_fun,time,options);
   plot_fig=0;
   for i=1:n
      bg_color=get(M1_handle1(n*(i-1)+j),'Backgroundcolor');
      if ~all(bg_color==[1 1 1])
         plot_fig=1;
      end
   end
   if plot_fig
   if j==1
      if get(Plot_handle(2),'Value')
         temp=get(gcf,'Position');
         tmp=length(figMSF_h)+1;
         figMSF_h(tmp)=crfig(temp(1)+20,temp(2)+temp(4)-445,600,440,...
            'Time Response of the Model State Feedback MIMO system',...
            [.5 .55 .6],'none','on');
      M1_handle2(:,j)=Xuiarray([80 415 20*n 10],1,n,0,[0],...
         'push','p_index=1;imcmenuM;','','',4710,figMSF_h(tmp));
         ax_h(1)=subplot(2,1,1);grid on
         title('Control efforts when only setpoint 1 is active.');
         set(gca,'color',[.55 .55 .65]);
         ylabel('Control efforts');
         ax_h(2)=subplot(2,1,2);grid on
			ylabel('Outputs ( i )');
			xlabel('Time');
			set(gca,'color',[.55 .55 .65]);
      else
         figure(figMSF_h(1));
         ax_h(1)=axis_handle(1,1);
         ax_h(2)=axis_handle(2,1);
         if ~get(Keep_handle,'Value')
            axes(ax_h(1)); cla;grid on
            axes(ax_h(2)); cla;grid on
         end
      end
      for i=1:n
         bg_color=get(M1_handle1(n*(i-1)+j),'Backgroundcolor');
         tmp=COLOR_MAP((n*(i-1)+j)*color_step,:);
         set(M1_handle2(i,j),'Backgroundcolor',tmp);
         if ~all(bg_color==[1 1 1])
            axes(ax_h(1)); hold on
            plot(t,sat_effort(:,i),'color',tmp);
            axes(ax_h(2)); hold on
            plot(t,yout(:,i),'color',bg_color);
         else
            axes(ax_h(1)); hold on
            plot(t,sat_effort(:,i),'color',tmp);
         end
      end
   else
      [tmp,tmp1]=size(axis_handle);
      if get(Plot_handle(2),'Value') | tmp1<j | ~ishandle(figMSF_h(j))
         temp=get(gcf,'Position');
         figMSF_h(j)=crfig(temp(1)+20,temp(2)+temp(4)-445,600,440,...
            'Time Response of the Model State Feedback MIMO system',...
            [.5 .55 .6],'none','on');
         ax_h(1)=subplot(2,1,1);grid on
         title(['Control efforts when only setpoint ' num2str(j) ' is active.']);
         set(gca,'color',[.55 .55 .65]);
         ylabel('Control efforts');
         ax_h(2)=subplot(2,1,2);grid on
			ylabel('Outputs ( i )');
			xlabel('Time');
			set(gca,'color',[.55 .55 .65]);
         axis_handle(1,j)=ax_h(1);
         axis_handle(2,j)=ax_h(2);
      M1_handle2(:,j)=Xuiarray([80 415 20*n 10],1,n,0,[0],...
         'push','p_index=1;imcmenuM;','','',4710,figMSF_h(j));
      else
         figure(figMSF_h(j));
         ax_h(1)=axis_handle(1,j);
         ax_h(2)=axis_handle(2,j);
         if ~get(Keep_handle,'Value')
            axes(ax_h(1)); cla;grid on
            axes(ax_h(2)); cla;grid on
         end
      end
      for i=1:n
         bg_color=get(M1_handle1(n*(i-1)+j),'Backgroundcolor');
         tmp=COLOR_MAP((n*(i-1)+j)*color_step,:);
         set(M1_handle2(i,j),'Backgroundcolor',tmp);
         if ~all(bg_color==[1 1 1])
            axes(ax_h(1)); hold on
            plot(t,sat_effort(:,i),'color',tmp);
            axes(ax_h(2)); hold on
            plot(t,yout(:,i),'color',bg_color);
         else
            axes(ax_h(1)); hold on
            plot(t,sat_effort(:,i),'color',tmp);
         end
      end
   end
   end
end