function [mq]=mq_gen(mnummt,mdenmt,mdeadmt,qnummt,qdenmt,order,y)
% This function generates mq varaible to be used by qd_mat function
% The two function must be used together

mq={''};
if isempty(mnummt) | isempty(mdenmt) | isempty(qnummt) |isempty(qdenmt)
   return
end
if iscell(mnummt)
   numMs=mt2poly(mnummt{1},y);
   denMs=mt2poly(mdenmt{2},y);
   num=conv(numMs,denMs);
   den=mt2poly(qnummt,y);
   [num,den]=zero_cancel(num,den);
   if ~isempty(mdeadmt{1})
      mq{1}=['(' mtx2str(num,2) '/' mtx2str(den,2) '*' mtx2str(mdeadmt{1},4) '+'];
   else
      mq{1}=['(' mtx2str(num,2) '/' mtx2str(den,2) '+'];
   end
   numMs=mt2poly(mnummt{2},y);
   denMs=mt2poly(mdenmt{1},y);
   num=conv(numMs,denMs);
   den=mt2poly(qnummt,y);
   [num,den]=zero_cancel(num,den);
   if ~isempty(mdeadmt{2})
      mq{1}=[mq{1} mtx2str(num,2) '/' mtx2str(den,2) '*' mtx2str(mdeadmt{2},4) ')'];
   else
      mq{1}=[mq{1} mtx2str(num,2) '/' mtx2str(den,2) ')'];
   end
   numMs=mt2poly(mdenmt{2},y);
   denMs=mt2poly(mdenmt{1},y);
   num=conv(numMs,denMs);
   den=mt2poly(qdenmt,y);
   [num,den]=zero_cancel(num,den);
   mq{1}=[mq{1} '/' mtx2str(num,2) '*' mtx2str(den,2) '/(e*s+1)^' num2str(order)];
   mq{2}='1';
else
[numMs]=mt2poly(mnummt,y);
[denMs]=mt2poly(mdenmt,y);
[mdeadx,mnumT,mdenT]=mt2dt(mdeadmt,y);
[denCs]=mt2poly(qnummt,y);
[numCs]=mt2poly(qdenmt,y);
numMQ=conv(numMs,numCs);
denMQ=conv(denMs,denCs);
if length(numMQ)==length(denMQ) & all(numMQ==denMQ)
	mq=cell(2,1);
   if ~isempty(mdeadmt)
      mq{1}=[mtx2str(mdeadmt,4) '/(e*s+1)^' num2str(order)];
      if imag(mdeadmt)==0
         temp=num2str(mdeadmt);
      else
         temp=['y(' num2str(imag(mdeadmt)) ')'];
      end
      mq{2}=['(-' temp '-e*' num2str(order) '/(e*s+1))'];
   else
      mq{1}=['1/(e*s+1)^' num2str(order)];
      mq{2}=['(-e*' num2str(order) '/(e*s+1))'];
   end
   
else
   temp=gcdpoly(numMQ,denMQ);
   numMQ=deconv(numMQ,temp);
   denMQ=deconv(denMQ,temp);
   mq=cell(2,2);
   if isempty(mdeadmt)
      mq{1,1}=['1/(e*s+1)^' num2str(order)];
      mq{1,2}=[mtx2str(numMQ,2) '/' mtx2str(denMQ,2)];
      mq{2,1}=['(-e*' num2str(order) '/(e*s+1))'];
   else
      mq{1,1}=[mtx2str(mdeadmt,4) '/(e*s+1)^' num2str(order)];
      mq{1,2}=[mtx2str(numMQ,2) '/' mtx2str(denMQ,2)];
      if imag(mdeadmt)==0
         temp=num2str(mdeadmt);
      else
         temp=['y(' num2str(imag(mdeadmt)) ')'];
      end
      mq{2,1}=['(-' temp '-e*' num2str(order) '/(e*s+1))'];
   end
	temp=polyder(numMQ);
   if length(temp)==1 & temp==0
      mq{2,2}=['(-' num2str(numMQ) '*' mtx2str(polyder(denMQ),2) '/' mtx2str(denMQ,2) '^2)'];
   else
      mq{2,2}=['(' mtx2str(temp,2) '/' mtx2str(denMQ,2) ...
        '-' mtx2str(numMQ,2) '*' mtx2str(polyder(denMQ),2) '/' mtx2str(denMQ,2) '^2)'];
   end
end
end % if iscell   

function [a,b]=zero_cancel(a,b)
g=gcdpoly(a,b);
a=deconv(a,g);
b=deconv(b,g);
