function [numC,denC]=pid_tf(numPs,denPs,numT,denT,numPinvs,denPinvs,denFs)
%This function compute PID equivalent transfer function, q/(1-pq).
%(The resulting numC, denC will be used to compute PID prarmeter later)

[numPQ,denPQ]=combind(numPs,denPs,denPinvs,numPinvs);

% Form final PQ including deadtime

numPQ=conv(numPQ,numT);
denPQ=conv(denPQ,denT);

% Form C = Q/(1-PQ) to be approximated with the PID

numC=conv(denPinvs,denPQ);
denC=conv(numPinvs,polyadd(conv(denPQ,denFs),-numPQ));
